default:
  image:
    name: registry.gitlab.com/buzzdeploy/containers/pipeline-containers/ubtf-1.2.9-1.0.0/amd64
  tags: 
    - k3s
    - amd64

variables:
  PROJECT_ID: ${CI_PROJECT_ID}
  TF_USERNAME: "gitlab-runner"
  PLAN: plan.tfplan
  JSON_PLAN_FILE: tfplan.json
  TF_IN_AUTOMATION: "true"
  TF_ROOT: ${CI_PROJECT_DIR}
  # TF_STATE_NAME: ${TF_STATE_NAME:-default} 


.gitlab-tf-backend: &gitlab-tf-backend
  - export TF_ADDRESS=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/terraform/state/${ENV_NAME}
  - export TF_HTTP_ADDRESS=${TF_ADDRESS}
  - export TF_HTTP_LOCK_ADDRESS=${TF_ADDRESS}/lock
  - export TF_HTTP_LOCK_METHOD=POST
  - export TF_HTTP_UNLOCK_ADDRESS=${TF_ADDRESS}/lock
  - export TF_HTTP_UNLOCK_METHOD=DELETE
  - export TF_HTTP_USERNAME=gitlab-ci-token
  - export TF_HTTP_PASSWORD=${CI_JOB_TOKEN}
  - export TF_HTTP_RETRY_WAIT_MIN=5
  - echo "Using HTTP Backend at $TF_HTTP_ADDRESS"
  - echo $sshkey > appbuzz
  - chmod 600 appbuzz 
  - export TF_VAR_ssh_key="$(pwd)/appbuzz"
  - echo $sshkeypub > appbuzz.pub
  - chmod 600 appbuzz.pub
  - export TF_VAR_ssh_key_pub="$(pwd)/appbuzz.pub"
  - terraform --version
  - terraform init -reconfigure   

stages:
  - launch
  - configure
  - bubble
  - destroy
  - clean-bucket

# Anchors of deploy and destroy
.deploy_cluster:
  script:
    - *gitlab-tf-backend
    - ls -lsa
    - terraform apply -auto-approve
    - ls -lsa
  artifacts:
    expire_in: 90 days
    name: $CI_COMMIT_REF_SLUG
    reports:
      dotenv: deploy.env
  environment:
    name: $ENV_NAME 
    on_stop: destroy

.configure_cluster:
  script:
    - cd lincli
    - bash getlinodes.sh
    - bash restart.sh
    - cd ../ansible
    - bash k3s_install_join.sh
  image: registry.gitlab.com/buzzdeploy/containers/pipeline-containers/ubpy-3.9-amd64/amd64:latest

.bubble:
  script:
    - source kubeConfigFromBucket.sh
    - ls -lsa
    - echo "Kubeconfig; ${KUBECONFIG}"
    - cd /workdir
    - git clone --branch $ZARF_BRANCH https://github.com/defenseunicorns/zarf zarf
    - cd zarf
    - git branch -v
    - ls -lsa
    - make build-cli-linux-amd init-package build-ui
    - cd build
    - ls -lsa
    - ./zarf init --confirm --components git-server
  image: registry.gitlab.com/buzzdeploy/containers/lollipop/ubzb-22020109-amd64:latest-amd64

.zarf-cli-init:
  script:
    - source kubeConfigFromBucket.sh
    - ls -lsa
    - echo "Kubeconfig; ${KUBECONFIG}"
    - cd /workdir
    - git clone --branch $ZARF_BRANCH https://github.com/defenseunicorns/zarf zarf
    - cd zarf
    - git branch -v
    - ls -lsa
    # - sleep 50m
    - make build-cli-linux-amd init-package
    - cd build
    - ls -lsa
    - ./zarf init --confirm --components git-server
  image: registry.gitlab.com/buzzdeploy/containers/lollipop/ubzb-22020109-amd64:latest-amd64

.destroy: 
  stage: destroy
  script:
    - *gitlab-tf-backend
    - terraform destroy -auto-approve
    - ls -lsa
  environment:
    name: $ENV_NAME 
    action: stop
  resource_group: $RESOURCE_GROUP
  when: manual

.clean-bucket:
  stage: clean-bucket
  script:
    - bash delFromBucket.sh  
  image: registry.gitlab.com/buzzdeploy/containers/pipeline-containers/ubpy-3.9-amd64/amd64:latest

deploy:
  stage: launch
  variables:
    ENV_NAME: dev
    RESOURCE_GROUP: app
  extends:
    - .deploy_cluster
  only:
    - main

config:
  stage: configure
  variables:
    ENV_NAME: dev
    RESOURCE_GROUP: app
  extends:
    - .configure_cluster
  only:
    - main

zarf-cli-init:
  stage: bubble
  variables:
    ENV_NAME: dev
    RESOURCE_GROUP: app
  extends:
    - .zarf-cli-init
  only:
    - main

destroy:
  needs: [deploy]
  variables: 
    ENV_NAME: dev
    RESOURCE_GROUP: app
  extends:
    - .destroy
  only:
    - main

clean-bucket:
  needs: [destroy]
  variables: 
    ENV_NAME: dev
    RESOURCE_GROUP: app
  extends:
    - .clean-bucket
  only:
    - main
 
